---
title: AudioParam.exponentialRampToValueAtTime()
slug: Web/API/AudioParam/exponentialRampToValueAtTime
tags:
  - API
  - AudioParam
  - Method
  - Reference
  - Web Audio API
  - exponentialRampToValueAtTime
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p>The <strong><code>exponentialRampToValueAtTime()</code></strong> method of the {{ domxref("AudioParam") }} Interface schedules a gradual exponential change in the value of the {{domxref("AudioParam")}}. The change starts at the time specified for the <em>previous</em> event, follows an exponential ramp to the new value given in the <code>value</code> parameter, and reaches the new value at the time given in the <code>endTime</code> parameter.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Exponential ramps are considered more useful when changing frequencies or playback rates than linear ramps because of the way the human ear works.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var AudioParam = AudioParam.exponentialRampToValueAtTime(<em>value</em>, <em>endTime</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>value</dt>
 <dd>A floating point number representing the value the <code>AudioParam</code> will ramp to by the given time.</dd>
 <dt>endTime</dt>
 <dd>A double representing the exact time (in seconds) after the ramping starts that the changing of the value will stop.</dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>A reference to this <code>AudioParam</code> object. In some browsers older implementations of this interface return void.</p>

<h2 id="Examples">Examples</h2>

<p>In this example, we have a media source with two control buttons (see the <a href="https://github.com/mdn/webaudio-examples/tree/master/audio-param">audio-param repo</a> for the source code, or <a href="https://mdn.github.io/webaudio-examples/audio-param/">view the example live</a>.) When these buttons are pressed, <code>exponentialRampToValueAtTime()</code> is used to fade the gain value up to 1.0, and down to 0, respectively. This is pretty useful for fade in/fade out effects:</p>

<pre class="brush: js;highlight[32,37]">// create audio context
var AudioContext = window.AudioContext || window.webkitAudioContext;
var audioCtx = new AudioContext();

// set basic variables for example
var myAudio = document.querySelector('audio');
var pre = document.querySelector('pre');
var myScript = document.querySelector('script');

pre.innerHTML = myScript.innerHTML;

var expRampPlus = document.querySelector('.exp-ramp-plus');
var expRampMinus = document.querySelector('.exp-ramp-minus');

// Create a MediaElementAudioSourceNode
// Feed the HTMLMediaElement into it
var source = audioCtx.createMediaElementSource(myAudio);

// Create a gain node and set its gain value to 0.5
var gainNode = audioCtx.createGain();

// connect the AudioBufferSourceNode to the gainNode
// and the gainNode to the destination
gainNode.gain.setValueAtTime(0, audioCtx.currentTime);
source.connect(gainNode);
gainNode.connect(audioCtx.destination);

// set buttons to do something onclick
expRampPlus.onclick = function() {
  gainNode.gain.exponentialRampToValueAtTime(1.0, audioCtx.currentTime + 2);
}

expRampMinus.onclick = function() {
  gainNode.gain.exponentialRampToValueAtTime(0.01, audioCtx.currentTime + 2);
}
</pre>

<div class="note">
<p><strong>Note</strong>: A value of 0.01 was used for the value to ramp down to in the last function rather than 0, as an <em>invalid or illegal string</em> error is thrown if 0 is used — the value needs to be positive.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audioparam-exponentialramptovalueattime', 'exponentialRampToValueAtTime')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioParam.exponentialRampToValueAtTime")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
